<?php

class galleryviewWidget extends CWidget {
        public $scriptUrl;

        public $themeUrl;
        public $smallwidth=30;
        public $smallheight=30;
        public $bigwidth=300;
        public $bigheight=300;
        public $itemview='galleryviewWidget';
        public $theme='dark';
        public $overlay_color="#222";
        public $overlay_text_color="white";
        public $caption_text_color="#222";
        public $scriptFile=array('jquery.easing.1.3.js','jquery.galleryview-1.1.js','jquery.timers-1.1.2.js');
        public $size=5;
        public $cssFile=array('galleryview.css');

        public $data=array();

        public $options=array();

        public $htmlOptions=array();

        public $all=TRUE;

        public function init() {
            $this->resolvePackagePath();
            $this->registerCoreScripts();
            parent::init();
        }

        protected function resolvePackagePath() {
            if($this->scriptUrl===null || $this->themeUrl===null) {
                $basePath=Yii::getPathOfAlias('application.extensions.galleryview');
                $baseUrl=Yii::app()->getAssetManager()->publish($basePath);
                if($this->scriptUrl===null)
                    $this->scriptUrl=$baseUrl;
                if($this->themeUrl===null)
                    $this->themeUrl=$baseUrl;
            }
        }

        protected function registerCoreScripts() {
            $cs=Yii::app()->getClientScript();
            if(is_string($this->cssFile))
                $this->registerCssFile($this->cssFile);
            else if(is_array($this->cssFile)) {
                foreach($this->cssFile as $cssFile)
                    $this->registerCssFile($cssFile);
            }

            $cs->registerCoreScript('jquery');
            if(is_string($this->scriptFile))
                $this->registerScriptFile($this->scriptFile);
            else if(is_array($this->scriptFile)) {
                foreach($this->scriptFile as $scriptFile)
                    $this->registerScriptFile($scriptFile);
            }
        }

        protected function registerScriptFile($fileName,$position=CClientScript::POS_HEAD) {
            Yii::app()->clientScript->registerScriptFile($this->scriptUrl.'/'.$fileName,$position);
        }
        protected function registerCssFile($fileName) {
            Yii::app()->clientScript->registerCssFile($this->themeUrl.'/'.$fileName);
        }
        public function run() {

            $cs = Yii::app()->getClientScript();
            Yii::app()->clientScript->registerCoreScript('jquery');
            $this->registerCoreScripts();
            
                $this->render($this->itemview);

        }
}
